/* Writes TAG from MP3 file to list */
                                         
/* Banner */
Say 'Writes TAG from MP3 file to list'
Say

/* Some startup operations */
Trace Off
Signal On Syntax Name IntError
Signal On Halt Name CtrlBreak
Signal Off Error
Signal Off NoValue
Call RxFuncAdd "SysLoadFuncs", "RexxUtil", "sysloadfuncs"
Call SysLoadFuncs

/* Get command line args */
parse arg list
if list = '' then list = '/h'

/* Help */
If (list = "/?") | (list = "-?") | (list = "-h") | (list = "/h") | (list = "--help") Then Do

  Say "Usage: TAGinfoW path\Files.BBS" || "0A0D"x ||,
      "  It scans TAG info structure of MP3 files and writes to filelist Files.BBS" || "0A0D"x ||,
      " " || "0A0D"x ||,
      "  Look at ReadMe how to create the structure of Files.BBS" || "0A0D"x ||,
      " " || "0A0D"x 
  Exit 1
End   

/* Process parameters */
if right(list, 1) = '\' then list = list||'Files.BBS'
mp3path = left(list,lastpos('\',list))
say 'looking for MP3 files'
Call SysFileTree mp3path||'*.MP3', 'fil', 'FO'
If fil.0 = 0 Then Do
  Say "No files found."
  Exit 1
End
  
/* Main loop */
Call Stream list, "C", "OPEN WRITE"

do i = 1 to fil.0
    Call Charout list, left(Filespec('name', fil.i),45)||'@'
   
/* Checking ID3 tag in MP3 file */
    offset = Stream(fil.i, 'c', 'QUERY SIZE') - 127
    IDdata = CharIn(fil.i, offset, 128)
    Call Stream fil.i, "C", "CLOSE"

    If Left(IDdata, 3) = "TAG"
    Then Call Lineout list, Substr(IDdata,4,124)||C2D(SubStr(IDdata, 128, 1))
    Else Call Lineout list, copies(' ',124)||'255'

    say left(Filespec('name', fil.i),45)||offset||' bytes scaned' 
End
Call Stream list, "C", "CLOSE"

  
/* All OK ! */
Exit 0

/* Signal handlers */

IntError:
  Say
  Say "Internal error" RC "at line" SIGL
  Exit -5

CtrlBreak:
  Say
  Say "Ctrl-Break pressed!"
  Exit -1

/* End of TAGinfoR.CMD */
