/* Writes TAG to MP3 file from BBS list */
                                         
/* Banner */
Say 'Writes TAG to MP3 file from BBS list'
Say

/* Some startup operations */
Trace Off
Signal On Syntax Name IntError
Signal On Halt Name CtrlBreak
Signal Off Error
Signal Off NoValue
Call RxFuncAdd "SysLoadFuncs", "RexxUtil", "sysloadfuncs"
Call SysLoadFuncs

/* Get command line args */
parse arg list
if list = '' then list = '/h'

/* Help */
If (list = "/?") | (list = "-?") | (list = "-h") | (list = "/h") | (list = "--help") Then Do

  Say "Usage: TAGinfoW path\Files.BBS" || "0A0D"x ||,
      "  It updates TAG info structure of MP3 files according to filelist Files.BBS" || "0A0D"x ||,
      " " || "0A0D"x ||,
      "  Look at ReadMe how to create the structure of Files.BBS" || "0A0D"x ||,
      " " || "0A0D"x 
  Exit 1
End   

/* Process parameters */
if right(list, 1) = '\' then list = list||'Files.BBS'
say 'looking for "'list'":'
if stream(list,'c','QUERY EXISTS')='' then do
   say list 'not found'
   Exit 0
   end
  
/* Main loop */
mp3path = left(list,lastpos('\',list))
Call Stream list, "C", "OPEN READ"
  Do While Stream(list) = "READY"
    Genre=D2C(33)
    Parse Value LineIn(list) With data
    If data  = '' Then Leave
    mp3file=left(data, pos('@',data)-1)
    TAGinf=strip(substr(data, pos('@',data)+1))
    If mp3file = '' Then Leave
    If left(mp3file,1) <> ";" Then Do
    
/* Checking ID3 tag in MP3 file */
    offset = Stream(mp3path||mp3file, 'c', 'QUERY SIZE') - 127
    IDdata = CharIn(mp3path||mp3file, offset, 128)
    If Left(IDdata, 3) <> "TAG" Then offset = offset + 127
    If Length(TAGinf) > 124 Then Genre = D2C(Substr(TAGinf,125))
    IDdata = Left('TAG'||TAGinf, 127)||Genre

/* Updating ID3 tag in MP3 file */
    Call Stream mp3path||mp3file, 'C', 'OPEN WRITE'
    Call Stream mp3path||mp3file, 'C', 'SEEK' offset
    Call Charout mp3path||mp3file, IDdata
    Call Stream mp3path||mp3file, 'C', 'CLOSE'
    say mp3file||'   '||offset||' bytes updated' 
    End
  End
  Call Stream list, "C", "CLOSE"

  
/* All OK ! */
Exit 0

/* Signal handlers */

IntError:
  Say
  Say "Internal error" RC "at line" SIGL
  Exit -5

CtrlBreak:
  Say
  Say "Ctrl-Break pressed!"
  Exit -1

/* End of TAGinfoW.CMD */
